<!---
      Query database for sales data
      --->
<cf_xquery name="salesData">
   <recs>
      <rec name="Tom" sales="120" />
      <rec name="Dick" sales="140" />
      <rec name="Harry" sales="80" />
   </recs>
</cf_xquery>


<!---
      Get absolute path to file we're going to generate
      and delete the file if it already exists.
      --->
<cfset fileName = expandPath("files\01_Auto_Chart.xls")>
<cfif fileExists(fileName)>
   <cffile action="delete" file="#fileName#">
</cfif>
      

<!--- 
      Grab reference to Excel
      --->
<cftry>
   <cfobject 
      name="xlApp" 
      action="connect" 
      class="Excel.Application">
      
   <cfcatch type="Any">
      
      <cfobject 
         name="xlApp" 
         action="create" 
         class="Excel.Application">
         
   </cfcatch>
</cftry>


<!---
      Create a new workbook and grab a reference to the first sheet
      --->
<cfset xlWbs = xlApp.Workbooks>
<cfset xlWb = xlWbs.add("")>
<cfset xlWs = xlWb.activeSheet>


<!---
      Loop through our data put it into Excel
      --->
<cfloop query="salesData">
   
   <cfset c = xlWs.range("A" & salesData.currentRow+1)>
   <cfset c.value2 = salesData.name>
   <cfset releaseComObject(c)>
   
   <cfset c = xlWs.range("B" & salesData.currentRow+1)>
   <cfset c.value2 = salesData.sales>
   <cfset releaseComObject(c)>
</cfloop>   


<!---
      Select the data and create a chart
      --->
<cfset xlRange = xlWs.range("A1:B4")>
<cfset xlCharts = xlWb.charts>
<cfset xlChart = xlCharts.add()>
<cfset xlChart.chartType = -4102> <!--- xl3DPie --->
<cfset xlChart.setSourceData(xlRange, 2)> <!--- Source:=Range("A1:B4"), PlotBy:= xlColumns --->
<cfset xlChart.location(1, "Sales By Employee")> <!--- xlLocationAsNewSheet, Name --->

<cfset xlWb.saveAs(fileName)>
<cfset xlWb.close()>


<!---
      Release all COM objects
      --->
<cfset releaseComObject(xlRange)>
<cfset releaseComObject(xlChart)>
<cfset releaseComObject(xlWs)>
<cfset releaseComObject(xlWb)>
<cfset releaseComObject(xlWbs)>
<cfset releaseComObject(xlApp)>


<cfheader 
   name="Content-Disposition" 
   value="attachment; filename=""#getFileFromPath(fileName)#""">
   
<cfcontent 
   type="application/vnd.ms-excel" 
   file="#fileName#">

<!---
   
   Code generated by Record Macro
   
    Range("A2").Select
    ActiveCell.FormulaR1C1 = "Tom"
    Range("A3").Select
    ActiveCell.FormulaR1C1 = "Dick"
    Range("A4").Select
    ActiveCell.FormulaR1C1 = "Harry"
    Range("B1").Select
    ActiveCell.FormulaR1C1 = "Sales"
    Range("B2").Select
    ActiveCell.FormulaR1C1 = "120000"
    Range("B3").Select
    ActiveCell.FormulaR1C1 = "140000"
    Range("B4").Select
    ActiveCell.FormulaR1C1 = "110000"
    Range("A1:B4").Select
    Range("B4").Activate
    Charts.Add
    ActiveChart.ChartType = xl3DPie
    ActiveChart.SetSourceData Source:=Sheets("Sheet1").Range("A1:B4"), PlotBy:= _
        xlColumns
    ActiveChart.Location Where:=xlLocationAsNewSheet, Name:="Sales"
    Sheets("Sheet1").Select
--->

