<!---
      04_Jet_Read.cfm
      
      Example of interacting with MS Office through the Jet engine.
      
      Accepts a file upload, reads in the data, and displays it in a
      formatted table.
      
      --->
      

<!---
      Start with form for people to upload
      --->
<cfoutput>
   <h1>MS Office - JET Example</h1>
   <p>Upload a file to see it formatted nicely.  The file must be formatted as follows.</p>
   <ul>
      <li>Microsoft Excel file</li>
      <li>Must contain a worksheet name "Sales"</li>
      <li>Must contain two columns with headings "Salesperson" and "SalesAmount"</li>
   </ul>
   <form action="#cgi.script_name#" method="post" enctype="multipart/form-data">
      <input type="file" name="fileName" />
      <input type="submit" value="Upload & Display" />
   </form>
</cfoutput>

<cfif structKeyExists(form, "fileName")>
   <h1>Here's your data</h1>
   
   <cfset tempFile = expandPath("files\04_Jet_Read_Temp.xls")>
   
   <cffile 
      action="upload" 
      fileField="fileName" 
      destination="#tempFile#" 
      nameConflict="overwrite">
   
   <cfquery name="excelData" datasource="proxy">
      SELECT Salesperson, SalesAmount
      FROM "Excel 8.0; DATABASE=#tempFile#; HDR=YES".[Sales$]
   </cfquery>
   
   <table border="0" cellpadding="0" cellspacing="0">
      <tr>
         <th>Sales Person</th>
         <th>&nbsp;</th>
         <th>Sales this period</th>
      </tr>
      
      <cfoutput query="excelData">
         <tr>
            <td>#excelData.salesPerson#</td>
            <td width="15">&nbsp;</td>
            <td>#excelData.salesAmount#</td>
         </tr>
      </cfoutput>
   </table>
   
</cfif>
   