<!---
      the ?xml? declaration must be first character, so use
      cfsilent or cfcontent to block out any whitespace from
      preparing data
      --->      
<cfsilent>

<cf_xquery name="salesData">
   <recs>
      <rec salesPerson='Tom' category='Books' salesAmount='50' />
      <rec salesPerson='Tom' category='Electronics' salesAmount='20' />
      <rec salesPerson='Tom' category='Toys' salesAmount='20' />
      <rec salesPerson='Tom' category='Junk' salesAmount='30' />
      <rec salesPerson='Dick' category='Books' salesAmount='70' />
      <rec salesPerson='Dick' category='Electronics' salesAmount='60' />
      <rec salesPerson='Dick' category='Toys' salesAmount='10' />
      <rec salesPerson='Dick' category='Junk' salesAmount='0' />
      <rec salesPerson='Harry' category='Books' salesAmount='0' />
      <rec salesPerson='Harry' category='Electronics' salesAmount='0' />
      <rec salesPerson='Harry' category='Toys' salesAmount='30' />
      <rec salesPerson='Harry' category='Junk' salesAmount='50' />
   </recs>
</cf_xquery>

</cfsilent
><?xml version="1.0"?>
<Workbook 
   xmlns="urn:schemas-microsoft-com:office:spreadsheet" 
   xmlns:o="urn:schemas-microsoft-com:office:office" 
   xmlns:x="urn:schemas-microsoft-com:office:excel" 
   xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" 
   xmlns:html="http://www.w3.org/TR/REC-html40">
   
	<Styles>
		<Style ss:ID="Default" ss:Name="Normal">
			<Alignment ss:Vertical="Bottom"/>
			<Borders/>
			<Font ss:FontName="Verdana" x:Family="Swiss" ss:Size="18"/>
			<Interior/>
			<NumberFormat/>
			<Protection/>
		</Style>
		<Style ss:ID="title">
			<Font ss:FontName="Arial Rounded MT Bold" x:Family="Swiss" ss:Size="36" ss:Bold="1"/>
		</Style>
		<Style ss:ID="heading">
			<Font ss:FontName="Verdana" x:Family="Swiss" ss:Size="18" ss:Bold="1" ss:Underline="Single"/>
		</Style>
		<Style ss:ID="subTotal">
			<Font ss:FontName="Verdana" x:Family="Swiss" ss:Size="18" ss:Bold="1"/>
		</Style>
		<Style ss:ID="grandTotalLabel">
			<Font ss:FontName="Verdana" x:Family="Swiss" ss:Size="22" ss:Bold="1"/>
		</Style>
		<Style ss:ID="grandTotalValue">
			<Borders>
				<Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="2"/>
			</Borders>
			<Font ss:FontName="Verdana" x:Family="Swiss" ss:Size="22" ss:Bold="1"/>
		</Style>
	</Styles>
	
	<Worksheet ss:Name="Sales Report">
		<Table ss:ExpandedColumnCount="3" ss:ExpandedRowCount="27" x:FullColumns="1" x:FullRows="1">
			<Column ss:Width="198"/>
			<Column ss:Width="228"/>
			<Column ss:Width="152.25"/>
			<Row ss:Height="45" ss:StyleID="title">
				<Cell>
					<Data ss:Type="String">Sales Report</Data>
				</Cell>
			</Row>
			<Row ss:Height="22.5">
				<Cell>
					<Data ss:Type="String"><cfoutput>#dateFormat(now(), "mmmm, yyyy")#</cfoutput></Data>
				</Cell>
			</Row>
			<Row />
			<Row ss:Height="22.5" ss:StyleID="heading">
				<Cell>
					<Data ss:Type="String">Sales Person</Data>
				</Cell>
				<Cell>
					<Data ss:Type="String">Product Category</Data>
				</Cell>
				<Cell>
					<Data ss:Type="String">Sales Amount</Data>
				</Cell>
			</Row>
			<Row ss:Height="22.5"/>
         
         <cfset grandTotalRowCount = 0>
         
         <cfoutput query="salesData" group="salesPerson">
            <cfset displayName="#salesData.salesPerson#">
            <cfset groupRowCount = 0>
            <cfoutput>
      			<Row ss:Height="22.5">
      				<Cell>
      					<Data ss:Type="String">#displayName#</Data>
      				</Cell>
      				<Cell>
      					<Data ss:Type="String">#salesData.category#</Data>
      				</Cell>
      				<Cell>
      					<Data ss:Type="Number">#salesData.salesAmount#</Data>
      				</Cell>
      			</Row>
      			<cfset groupRowCount = groupRowCount + 1>
      			
      			<!---
      			      only display salesperson for first row in group
      			      --->
      			<cfset displayName="">
      			
            </cfoutput>
   			
   			<Row ss:Height="22.5"/>
   			
   			<Row ss:Height="22.5" ss:StyleID="subTotal">
   				<Cell ss:Index="2">
   					<Data ss:Type="String">Sub-Total</Data>
   				</Cell>
   				<Cell ss:Formula="=subTotal(9,R[-#groupRowCount+1#]C:R[-2]C)">
   					<Data ss:Type="Number" />
   				</Cell>
   			</Row>
   			<Row ss:Height="22.5"/>
   			
   			<!---
   			      add this group's row count to the grand total 
   			      and include the footer rows
   			      --->
   			<cfset grandTotalRowCount = grandTotalRowCount + groupRowCount + 3>
   			
         </cfoutput>


			<!---
			      Display a grand total
			      --->
			<Row ss:Height="27" ss:StyleID="grandTotalLabel">
				<Cell>
					<Data ss:Type="String">Grand Total</Data>
				</Cell>
				<cfoutput>
   				<Cell ss:Index="3" ss:StyleID="grandTotalValue" ss:Formula="=subTotal(9,R[-#grandTotalRowCount+1#]C:R[-2]C)">
   					<Data ss:Type="Number" />
   				</Cell>
				</cfoutput>
			</Row>
		</Table>
		
		<WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
			<DoNotDisplayGridlines/>
		</WorksheetOptions>
	</Worksheet>
</Workbook>


<!---
			Tell the browser this is an Excel workbook
			--->
<cfcontent type="application/vnd.ms-excel" reset="no">

<!---
			Tell the browser this is an attachment and
			provide a filename.
			--->
<cfheader 
	name="Content-Disposition" 
	value="attachment; filename=""SalesReport1.xls""">

<cfsetting showDebugOutput="false">
