<!---
      XQuery.cfm
      Samuel Neff (sam@rewindlife.com)
      
      
      Used for quick development and testing.  Creates a CF Query object
      from the inner HTML content in order to quickly create
      queries for testing.
      
      The actual element names are ignored, but the structure must be 
      maintained as per the examples.  Attribute names become field
      names.
      
      Params
      
         -> attributes.name  (defaults to xQuery)
      
      Usage example:
      
      
      <cf_XQuery name="myQuery">
         <records>
            <rec name="Tom" sales="120000" />
            <rec name="Dick" sales="140000" />
            <rec name="Harry" sales="110000" />
         </records>
      </cf_XQuery>
      
---><cfif thisTag.executionMode is "end"><cfsilent>   

   <cfparam name="attributes.name" default="xQuery" type="string">
   
   <cfset x = xmlParse(thisTag.generatedContent)>
   
   <cfset recs = x.xmlRoot.xmlChildren>
   
   <cfset rec = recs[1]>
   <cfset atts = rec.xmlAttributes>
   
   <cfset i = 1>
   <cfset fieldNames = arrayNew(1)>   
   <cfloop item="att" collection="#atts#">
      <cfset fieldNames[i] = att>
      <cfset i=i+1>
   </cfloop>
   
   <cfset oq = queryNew(arrayToList(fieldNames))>      
   
   <cfloop index="i" from="1" to="#arrayLen(recs)#">
      <cfset queryAddRow(oq)>
      
      <cfset atts = recs[i].xmlAttributes>
      <cfloop item="att" collection="#atts#">
         <cfset querySetCell(oq, att, atts[att])>
      </cfloop>
   
   </cfloop>
   
   <cfset caller[attributes.name] = oq>
   <cfset thisTag.generatedContent = "">
   
</cfsilent></cfif>